#ifndef CXXOMFORT_BACKPORTS_HPP
#define CXXOMFORT_BACKPORTS_HPP

/**
 * @file
 * @brief Central include for importing cxxomfort's @e backport features.
 * 
 * @code
#include <cxxomfort/backports.hpp>
 * @endcode
 * 
 * Including this header brings up the base cxxomfort 
 * utilities as well as the available backports for the major 
 * standard headers in the library.
 * 
 * For additions specific to cxxomfort see @c library.hpp .
 * 
 * */
#include "base.hpp"
#include "config.hpp"
#include "cxxo-utils.hpp"

#include "cstddef.hpp"
#include "cstdio.hpp" 
#include "cerrno.hpp" 
#include "cstdint.hpp" 
#include "cstring.hpp" 
#include "ctime.hpp" 

#include "array.hpp"
#include "algorithm.hpp" 
#include "functional.hpp" 
#include "iterator.hpp"
#include "limits.hpp"
#include "numeric.hpp" 
#include "utility.hpp"

#include "complex.hpp"
#include "cuchar.hpp" 
#include "string.hpp"

#include "memory.hpp"
#include "random.hpp"
#include "typeindex.hpp"
#include "tuple.hpp"
#include "ratio.hpp"
#include "system_error.hpp"
#include "type_traits.hpp"
#include "forward_list.hpp"

#include "string_view.hpp"

#include "bit.hpp"
#include "span.hpp"

#include "expected.hpp"

#include "ios.hpp" 
#include "ostream.hpp"
#include "iomanip.hpp" 

#endif
