#ifndef CXXOMFORT_UTIL_MOVE_00_HPP
#define CXXOMFORT_UTIL_MOVE_00_HPP

// Move emulation, deboostified from Boost
// (Dunno what's the point, Boost.Move is pretty self-standing)

#include "../config.hpp"
#if (CXXOMFORT_CXX_STD >= 2011)
    #error "Library error - this file should only be invoked with c++03"
#endif

namespace cxxomfort{

namespace move_detail {

template <bool If, typename A, typename B>
struct conditional { typedef B type; };

template <typename A, typename B>
struct conditional<true,A,B> { typedef A type; };


struct empty{};

} // move_detail

template <class T>
class rv
: public move_detail::conditional
    < (traits::is_fundamental<T>::value == false)
    , T
    , move_detail::empty
>::type {
    rv();
    ~rv();
    rv(rv const&);
    void operator=(rv const&);
} /*BOOST_MOVE_ATTRIBUTE_MAY_ALIAS*/;


//
// move 
// 

template <typename T>
inline T const& 
move (T const& x) throw() { return x; }

/*
template <class T>
inline rv<T>&
move (rv<T>& x) {
	return x;
}
*/


} // cxxomfort

namespace std {
	using cxxomfort::move;
}


#define CXXO_NONCOPYABLE_MOVABLE(TYPE)\

#define CXXO_COPYABLE_MOVABLE(TYPE)\

#define CXXO_COPYABLE_MOVABLE_NONASSIGNABLE(TYPE)\

#define CXXO_COPY_ASSIGN_REF(TYPE) const TYPE &

#define CXXO_RV_REF(TYPE) ::cxxomfort::rv< TYPE >&

#define CXXO_FWD_REF(TYPE) TYPE const&



#endif

