#ifndef CXXOMFORT_IMPL_TO_STRING_PRE97_HPP
#define CXXOMFORT_IMPL_TO_STRING_PRE97_HPP
/**
 * @file
 * @brief Implementation for std::to_string and allies 
 * @xrefitem std0string "<string>"
 *
 */

#include <cxxomfort/base.hpp>
#include <cxxomfort/cstdint.hpp>
#include <string>
#include <cstdio>
#include <stdlib.h> // for MSVC?

namespace cxxomfort { namespace cxxostd {

static inline 
std::string to_string (unsigned short u) {
	using namespace std;
	char buff[8]= {0};
	sprintf(buff,"%u",u);
	return std::string(buff);
}

static inline 
std::string to_string (signed short u) {
	using namespace std;
	char buff[8]= {0};
	sprintf(buff,"%d",u);
	return std::string(buff);
}

static inline 
std::string to_string (signed int u) {
	using namespace std;
	char buff[30]= {0};
	sprintf(buff,"%d",u);
	return std::string(buff);
}

static inline 
std::string to_string (unsigned int u) {
	using namespace std;
	char buff[30]= {0};
	sprintf(buff,"%u",u);
	return std::string(buff);
}

static inline 
std::string to_string (signed long int l) {
	using namespace std;
	char buff[30]= {0};
	sprintf(buff,"%ld",l);
	return std::string(buff);
}

static inline 
std::string to_string (unsigned long int l) {
	using namespace std;
	char buff[30]= {0};
	sprintf(buff,"%lu",l);
	return std::string(buff);
}


static inline 
std::string to_string (double f) {
	using namespace std;
	char buff[128]= {0};
	sprintf(buff,"%f",f);
	return std::string(buff);
}


} }

namespace std {
	using cxxomfort::cxxostd::to_string;
}

#endif
