#ifndef CXXOMFORT_IMPL_20_ITERATOR_ACCESS_HPP
#define CXXOMFORT_IMPL_20_ITERATOR_ACCESS_HPP
/**
 * @file
 * @brief Implementation of std::size , std::data , std::empty 
 */
#include <cxxomfort/config.hpp>
#include <cxxomfort/base/iterator.hpp> // also includes <iterator>

#include <cxxomfort/impl/p1227r0-ssize.hpp>

	#if defined(DOXYGEN_DOC)
namespace std {

/**
 * Returns the @e size of a sequence-like object, converted to an equivalent signed type.
 * 
 * @ingroup cxxo-sup-iterator
 * @xrefitem cxxo-sup-iterator "" "" Returns the size of a sequence-like, as a @c signed type.
 * @cxx20b Returns the size of a sequence-like, as a @c signed type.
 * 
 * @see @wg21{p1227r0} by Jorg Brown
 * 
 * @note not to be confused with the concept of absdistance() / absdiff() .
 * 
 * 
 * */
template <typename C> 
auto ssize (C& cs) -> typename std::make_signed<decltype(cs.size())>::type {}

}
	#endif
	
	#if (defined(CXXOFLAG_NO_STD_USING) && CXXOFLAG_NO_STD_USING>0 )
	#elif (CXXOMFORT_IMPLEMENTS_ssize == CXXO_IMPLSTATUS_BACKPORT() || CXXOMFORT_IMPLEMENTS_ssize == CXXO_IMPLSTATUS_EMULATION() )
namespace std {
	using ::cxxomfort::cxxostd::ssize;
}

	#endif

#endif

