#ifndef CXXOMFORT_IMPL_17_TYPE_TRAITS_HPP
#define CXXOMFORT_IMPL_17_TYPE_TRAITS_HPP

#include <cxxomfort/base.hpp>

#if (CXXOMFORT_CXX_STD >= 2020)

#else

namespace std {

// 
// is_bounded_array (C++20)
// 
template <typename T> struct is_bounded_array_impl : false_type {};
template <typename T, size_t N> struct is_bounded_array_impl <T[N]> : true_type {};
template <typename T> struct is_bounded_array 
: is_bounded_array_impl< typename drop_cv<T>::type > {};

// 
// is_unbounded_array (C++20)
// 
template <typename T> struct is_unbounded_array_impl : false_type {};
template <typename T> struct is_unbounded_array_impl <T[]> : true_type {};
template <typename T> struct is_unbounded_array 
: is_unbounded_array_impl< typename drop_cv<T>::type > {};


}

#endif // c++ std

#endif
