#ifndef CXXOMFORT_IMPL_CHARACTER_HPP
#define CXXOMFORT_IMPL_CHARACTER_HPP
/**
 * @file
 * @brief Meta information for character types.
 * 
 * Utility file similar to @c functionmeta.hpp .
 * 
 * */
#include <cstddef>
#include <cxxomfort/impl/07-type_traits.hpp>
//#include <cxxomfort/type_traits.hpp>

namespace cxxomfort { namespace impl{ namespace type_traits {

namespace ct = ::cxxomfort::traits;

//! Check if a type T is one of C++'s native character types.
template <typename T> struct is_character_type: ct::false_type {};
template <> struct is_character_type<char> : ct::true_type {};
template <> struct is_character_type<signed char> : ct::true_type {};
template <> struct is_character_type<unsigned char> : ct::true_type {};
template <> struct is_character_type<wchar_t> : ct::true_type {};

#if (CXXOMFORT_CXX_STD >= 2011)
template <> struct is_character_type<char16_t> : ct::true_type {};
template <> struct is_character_type<char32_t> : ct::true_type {};
#endif

}}}

#endif
