#ifndef CXXOMFORT_IMPL_METAPROGRAMMING_HPP
#define CXXOMFORT_IMPL_METAPROGRAMMING_HPP

#include <cxxomfort/base.hpp>
#include <cxxomfort/impl/07-type_traits.hpp>
//#include <type_traits>
#include <cxxomfort/type_traits.hpp>
#if (CXXOMFORT_CXX_STD>=1997)

namespace cxxomfort {
namespace traits {

template <typename T>
struct keep { typedef T type; };

template <typename T, template <class> class A1
    , template <class> class A2=keep
    , template <class> class A3=keep
    , template <class> class A4=keep
    , template <class> class A5=keep>
struct compose {
#if (0&& CXXOMFORT_COMPILER_ID==CXXO_COMPILERID_MSC)
    private:
    typedef typename A1<T>::type C;
    typedef typename A4<S4>::type S3;
    typedef typename A3<S3>::type S2;
    typedef typename A2<S2>::type S1;
    public:
    typedef typename A1<S1>::type type;
#else
    typedef typename A5<
        typename A4<
            typename A3<
                typename A2<
                    typename A1<T>::type
                >::type
            >::type
        >::type 
    >::type type;
#endif

};


template 
    <typename T0, typename T1, typename T2=std::false_type, 
    typename T3=std::false_type, typename T4=std::false_type
> struct make_and 
: public std::integral_constant 
<   bool, 
    T0::value && T1::value && T2::value && T3::value && T4::value
>
{};

template 
    <typename T0, typename T1, typename T2=std::false_type, 
    typename T3=std::false_type, typename T4=std::false_type
> struct make_or 
: public std::integral_constant 
<   bool,
    T0::value || T1::value || T2::value || T3::value || T4::value
>
{};



}}

#endif 
#endif
