#ifndef CXXOMFORT_IMPL_p0196_HPP
#define CXXOMFORT_IMPL_p0196_HPP
#include <cxxomfort/base.hpp>

namespace cxxomfort { namespace cxxostd { namespace experimental {
namespace nullable {

#if (CXXOMFORT_CXX_STD >= 2011)
template <class T> 
CXXO_CONSTEXPR bool has_value (T&& v) noexcept ;
#endif

struct none_t {
	explicit none_t () CXXOMFORT_CXX11_CODE(=default , {} );
	template <typename T> 
	operator T* () const CXXO_NOEXCEPT { return nullptr; }
};

CXXO_CONSTEXPR bool operator== (none_t, none_t) CXXO_NOEXCEPT { return true; }
CXXO_CONSTEXPR bool operator< (none_t, none_t) CXXO_NOEXCEPT { return false; }
CXXO_RELATIONAL_OPERATORS(none_t);

// factory 
CXXO_CONSTEXPR none_t 	none () CXXO_NOEXCEPTNOTHROW { 
	return none_t CXXOMFORT_CXX11_CODE({},()); 
}

} // nullable
} // experimental
}}
#endif
