#ifndef CXXOMFORT_IMPL_p1227_HPP
#define CXXOMFORT_IMPL_p1227_HPP

/**
 * @file
 * 
 * see: https://wg21.link/p1227r0

 * */

#include <cxxomfort/config.hpp>
#include <cxxomfort/cstddef.hpp>
#include <iterator>

#if (defined(__cpp_lib_ssize))
	#undef  CXXOMFORT_IMPLEMENTS_p1227r0
	#define CXXOMFORT_IMPLEMENTS_p1227r0 CXXO_IMPLSTATUS_NATIVE()
#elif (CXXOMFORT_CXX_STD >= 2014)
	//#pragma message("ssize 2014")
	#undef  CXXOMFORT_IMPLEMENTS_p1227r0
	#define CXXOMFORT_IMPLEMENTS_p1227r0 CXXO_IMPLSTATUS_BACKPORT()
	#define __cpp_lib_ssize (CXXOMFORT_CXX_STD*100)

namespace cxxomfort { namespace cxxostd {

template <typename C>
constexpr auto ssize (C const& c) 
-> typename std::common_type< std::ptrdiff_t, typename std::make_signed<decltype(c.size()) >::type >::type
{
	using R = typename std::common_type< std::ptrdiff_t, typename std::make_signed<decltype(c.size())>::type >::type;
	return static_cast<R>(c.size());
}

// for arrays
template <typename T, std::ptrdiff_t N>
constexpr std::ptrdiff_t ssize (T const (&)[N]) noexcept {
	return N;
}

} }

#elif (CXXOMFORT_CXX_STD >= 2011)
	#undef  CXXOMFORT_IMPLEMENTS_p1227r0
	#define CXXOMFORT_IMPLEMENTS_p1227r0 CXXO_IMPLSTATUS_EMULATION()
	#define __cpp_lib_ssize (CXXOMFORT_CXX_STD*100)

namespace cxxomfort { namespace cxxostd {

template <typename C>
constexpr typename std::make_signed< decltype( std::declval<C>().size() )>::type ssize (C const& c) {
	return (c.size());
}

// for arrays
template <typename T, std::ptrdiff_t N>
constexpr std::ptrdiff_t ssize (T const (&)[N]) noexcept {
	return N;
}

} }

#elif (CXXOMFORT_CXX_STD >= 1997)
	#undef  CXXOMFORT_IMPLEMENTS_p1227r0
	#define CXXOMFORT_IMPLEMENTS_p1227r0 CXXO_IMPLSTATUS_EMULATION()
	#define __cpp_lib_ssize 1

namespace cxxomfort { namespace cxxostd {

template <typename C>
std::ptrdiff_t ssize (C const& c) {
	return static_cast<std::ptrdiff_t>(c.size());
}

// for arrays
template <typename T, std::ptrdiff_t N>
std::ptrdiff_t ssize (T const (&)[N]) CXXO_NOEXCEPTNOTHROW {
	return N;
}

} }

#endif

#undef  CXXOMFORT_IMPLEMENTS_ssize 
#define CXXOMFORT_IMPLEMENTS_ssize CXXOMFORT_IMPLEMENTS_p1227r0

#endif
