#ifndef CXXOMFORT_IMPL_TO_BASIC_STRING_03_HPP
#define CXXOMFORT_IMPL_TO_BASIC_STRING_03_HPP

#include <cstring>
#include <sstream>
#include <ostream>

namespace cxxomfort { namespace impl { 
namespace string {

namespace {
struct no_ts {};
const no_ts NO = {};

template <typename Char>
std::basic_ostream<Char>& operator<<  (std::basic_ostream<Char>& os, no_ts) CXXO_NOEXCEPTNOTHROW {
	return os;
}

} // anon

template <typename Ch, 
    typename T0, typename T1, typename T2, typename T3, typename T4, 
    typename T5, typename T6, typename T7, typename T8, typename T9
>
std::basic_string<Ch> to_basic_string (
 	T0 const& t0, T1 const& t1, T2 const& t2, T3 const& t3, T4 const& t4, 
	T5 const& t5, T6 const& t6, T7 const& t7, T8 const& t8, T9 const& t9
) {
	std::basic_ostringstream<Ch> ox;
	ox<< t0<< t1<< t2<< t3<< t4<< t5<< t6<< t7<< t8<< t9;
	return ox.str();
}


template <typename Ch, 
    typename T0, typename T1, typename T2, typename T3, typename T4, 
    typename T5, typename T6, typename T7, typename T8
>
std::basic_string<Ch> to_basic_string (
 	T0 const& t0, T1 const& t1, T2 const& t2, T3 const& t3, T4 const& t4, 
	T5 const& t5, T6 const& t6, T7 const& t7, T8 const& t8
) {
	std::basic_ostringstream<Ch> ox;
	ox<< t0<< t1<< t2<< t3<< t4<< t5<< t6<< t7<< t8<< NO;
	return ox.str();
}

template <typename Ch, 
    typename T0, typename T1, typename T2, typename T3, typename T4, 
    typename T5, typename T6, typename T7
>
std::basic_string<Ch> to_basic_string (
 	T0 const& t0, T1 const& t1, T2 const& t2, T3 const& t3, T4 const& t4, 
	T5 const& t5, T6 const& t6, T7 const& t7
) {
	std::basic_ostringstream<Ch> ox;
	ox<< t0<< t1<< t2<< t3<< t4<< t5<< t6<< t7<< NO<< NO;
	return ox.str();
}

template <typename Ch, 
    typename T0, typename T1, typename T2, typename T3, typename T4, 
    typename T5, typename T6
>
std::basic_string<Ch> to_basic_string (
 	T0 const& t0, T1 const& t1, T2 const& t2, T3 const& t3, T4 const& t4, 
	T5 const& t5, T6 const& t6
) {
	std::basic_ostringstream<Ch> ox;
	ox<< t0<< t1<< t2<< t3<< t4<< t5<< t6<< NO;
	return ox.str();
}

template <typename Ch, 
    typename T0, typename T1, typename T2, typename T3, typename T4, 
    typename T5
>
std::basic_string<Ch> to_basic_string (
 	T0 const& t0, T1 const& t1, T2 const& t2, T3 const& t3, T4 const& t4, 
	T5 const& t5
) {
	std::basic_ostringstream<Ch> ox;
	ox<< t0<< t1<< t2<< t3<< t4<< t5<< NO;
	return ox.str();
}

template <typename Ch, 
    typename T0, typename T1, typename T2, typename T3, typename T4
>
std::basic_string<Ch> to_basic_string (
 	T0 const& t0, T1 const& t1, T2 const& t2, T3 const& t3, T4 const& t4
) {
	std::basic_ostringstream<Ch> ox;
	ox<< t0<< t1<< t2<< t3<< t4<< NO;
	return ox.str();
}

template <typename Ch, typename T0, typename T1, typename T2, typename T3>
std::basic_string<Ch> to_basic_string (
 	T0 const& t0, T1 const& t1, T2 const& t2, T3 const& t3
) {
	std::basic_ostringstream<Ch> ox;
	ox<< t0<< t1<< t2<< t3<< NO;
	return ox.str();
}

template <typename Ch, typename T0, typename T1, typename T2>
std::basic_string<Ch> to_basic_string (
 	T0 const& t0, T1 const& t1, T2 const& t2
) {
	std::basic_ostringstream<Ch> ox;
	ox<< t0<< t1<< t2<< NO;
	return ox.str();
}

template <typename Ch, typename T0, typename T1>
std::basic_string<Ch> to_basic_string (
 	T0 const& t0, T1 const& t1
) {
	std::basic_ostringstream<Ch> ox;
	ox<< t0<< t1<< NO;
	return ox.str();
}


// to_string (std::string)

template <	typename T0, typename T1, typename T2, typename T3, typename T4, 
			typename T5, typename T6, typename T7, typename T8, typename T9
>
std::string to_string (
 	T0 const& t0, T1 const& t1, T2 const& t2, T3 const& t3, T4 const& t4, 
	T5 const& t5, T6 const& t6, T7 const& t7, T8 const& t8, T9 const& t9
) {
	return to_basic_string<char>(t0,t1,t2,t3,t4,t5,t6,t7,t8,t9);
}

template <	typename T0, typename T1, typename T2, typename T3, typename T4, 
			typename T5, typename T6, typename T7, typename T8
>
std::string to_string (
 	T0 const& t0, T1 const& t1, T2 const& t2, T3 const& t3, T4 const& t4, 
	T5 const& t5, T6 const& t6, T7 const& t7, T8 const& t8
) {
	return to_basic_string<char>(t0,t1,t2,t3,t4,t5,t6,t7,t8);
}

template <	typename T0, typename T1, typename T2, typename T3, typename T4, 
			typename T5, typename T6, typename T7
>
std::string to_string (
 	T0 const& t0, T1 const& t1, T2 const& t2, T3 const& t3, T4 const& t4, 
	T5 const& t5, T6 const& t6, T7 const& t7
) {
	return to_basic_string<char>(t0,t1,t2,t3,t4,t5,t6,t7);
}

template <	typename T0, typename T1, typename T2, typename T3, typename T4, 
			typename T5, typename T6
>
std::string to_string (
 	T0 const& t0, T1 const& t1, T2 const& t2, T3 const& t3, T4 const& t4, 
	T5 const& t5, T6 const& t6
) {
	return to_basic_string<char>(t0,t1,t2,t3,t4,t5,t6);
}

template <	typename T0, typename T1, typename T2, typename T3, typename T4, 
			typename T5
>
std::string to_string (
 	T0 const& t0, T1 const& t1, T2 const& t2, T3 const& t3, T4 const& t4, 
	T5 const& t5
) {
	return to_basic_string<char>(t0,t1,t2,t3,t4,t5);
}

template <	typename T0, typename T1, typename T2, typename T3, typename T4 >
std::string to_string ( T0 const& t0, T1 const& t1, T2 const& t2, T3 const& t3, T4 const& t4
 ) {
	return to_basic_string<char>(t0,t1,t2,t3,t4);
}

template <	typename T0, typename T1, typename T2, typename T3 >
std::string to_string ( T0 const& t0, T1 const& t1, T2 const& t2, T3 const& t3
 ) {
	return to_basic_string<char>(t0,t1,t2,t3);
}

template <	typename T0, typename T1, typename T2 >
std::string to_string ( T0 const& t0, T1 const& t1, T2 const& t2
 ) {
	return to_basic_string<char>(t0,t1,t2);
}

template <	typename T0, typename T1 >
std::string to_string ( T0 const& t0, T1 const& t1
 ) {
	return to_basic_string<char>(t0,t1);
}


} // string
} } // cxxomfort::impl

#if 0

namespace cxxomfort { namespace impl {
namespace string {

namespace detail_string {

#if (CXXOMFORT_CXX_STD>=1997)
const struct no_t {
    template <typename Ch, typename Tr, typename Alloc>
    friend std::basic_ostringstream<Ch,Tr,Alloc>& 
    operator<< (std::basic_ostringstream<Ch,Tr,Alloc>& os, no_t const& n) {
        (void)n;
        return os;
	}

} noitem = {};

#else

const struct no_t {} noitem;

template <typename Ch, typename Tr, typename Alloc>
std::basic_ostringstream<Ch,Tr,Alloc>& 
operator<< (std::basic_ostringstream<Ch,Tr,Alloc>& os, no_t const& n) {
	(void)n;
	return os;
}

#endif


template <typename Stream>
struct streamizer {
    streamizer (Stream& s)
    : stream(s) 
    {
        using namespace std;
        stream.exceptions(ios_base::failbit | ios_base::badbit);
    }

    template <typename T>
    streamizer& operator<< (T const& t) const {
        stream<< t;
        return *this;
    }

    Stream& stream;
    
};


} // cxxomfort::library::string::detail_string


template <typename Ch, typename Tr, typename Alloc
, typename T0, typename T1, typename T2, typename T3, typename T4, typename T5, typename T6, typename T7, typename T8, typename T9
>
std::basic_string<Ch,Tr,Alloc> 
to_basic_string
(T0 const& t0, T1 const& t1, T2 const& t2, T3 const& t3, T4 const& t4, T5 const& t5, T6 const& t6, T7 const& t7, T8 const& t8, T9 const& t9) {
    using namespace std;
    typedef basic_ostringstream<Ch,Tr,Alloc> stream_t;
    stream_t stream;
    //detail_string::streamizer<stream_t> s(stream);
    int dummy[] = { (stream<< t0, 0)
        , (stream<< t1, 0), (stream<< t2, 0), (stream<< t3, 0)
        , (stream<< t4, 0), (stream<< t5, 0), (stream<< t6, 0)
        , (stream<< t7, 0), (stream<< t8, 0), (stream<< t9, 0)
    }; 
    (void)dummy;
    return stream.str();

}

// 9 arguments
template <typename Ch, typename Tr, typename Alloc
, typename T0, typename T1, typename T2, typename T3, typename T4, typename T5, typename T6, typename T7, typename T8
>
std::basic_string<Ch,Tr,Alloc> 
to_basic_string
(T0 const& t0, T1 const& t1, T2 const& t2, T3 const& t3, T4 const& t4, T5 const& t5, T6 const& t6, T7 const& t7, T8 const& t8) {
    return to_basic_string<Ch,Tr,Alloc> (t0,t1,t2,t3,t4,t5,t6,t7,t8,detail_string::noitem);
}

// 8 arguments
template <typename Ch, typename Tr, typename Alloc
, typename T0, typename T1, typename T2, typename T3, typename T4, typename T5, typename T6, typename T7
>
std::basic_string<Ch,Tr,Alloc> 
to_basic_string
(T0 const& t0, T1 const& t1, T2 const& t2, T3 const& t3, T4 const& t4, T5 const& t5, T6 const& t6, T7 const& t7) {
    return to_basic_string<Ch,Tr,Alloc> (t0,t1,t2,t3,t4,t5,t6,t7,detail_string::noitem, detail_string::noitem);
}

// 7 arguments
template <typename Ch, typename Tr, typename Alloc
, typename T0, typename T1, typename T2, typename T3, typename T4, typename T5, typename T6
>
std::basic_string<Ch,Tr,Alloc> 
to_basic_string
(T0 const& t0, T1 const& t1, T2 const& t2, T3 const& t3, T4 const& t4, T5 const& t5, T6 const& t6) {
    return to_basic_string<Ch,Tr,Alloc> (t0,t1,t2,t3,t4,t5,t6, detail_string::noitem, detail_string::noitem, detail_string::noitem);
}

// 6 arguments
template <typename Ch, typename Tr, typename Alloc
, typename T0, typename T1, typename T2, typename T3, typename T4, typename T5
>
std::basic_string<Ch,Tr,Alloc> 
to_basic_string
(T0 const& t0, T1 const& t1, T2 const& t2, T3 const& t3, T4 const& t4, T5 const& t5) {
    return to_basic_string<Ch,Tr,Alloc> (t0,t1,t2,t3,t4,t5,
    detail_string::noitem, detail_string::noitem, detail_string::noitem, detail_string::noitem);
}


// 5 arguments
template <typename Ch, typename Tr, typename Alloc
, typename T0, typename T1, typename T2, typename T3, typename T4
>
std::basic_string<Ch,Tr,Alloc> 
to_basic_string
(T0 const& t0, T1 const& t1, T2 const& t2, T3 const& t3, T4 const& t4) {
    return to_basic_string<Ch,Tr,Alloc> (t0,t1,t2,t3,t4,
    detail_string::noitem, detail_string::noitem, detail_string::noitem, detail_string::noitem, detail_string::noitem);
}

// 4 arguments
template <typename Ch, typename Tr, typename Alloc
, typename T0, typename T1, typename T2, typename T3
>
std::basic_string<Ch,Tr,Alloc> 
to_basic_string
(T0 const& t0, T1 const& t1, T2 const& t2, T3 const& t3) {
    return to_basic_string<Ch,Tr,Alloc> (t0,t1,t2,t3,
    detail_string::noitem, detail_string::noitem, detail_string::noitem, 
    detail_string::noitem, detail_string::noitem, detail_string::noitem);
}

// 3 arguments
template <typename Ch, typename Tr, typename Alloc
, typename T0, typename T1, typename T2
>
std::basic_string<Ch,Tr,Alloc> 
to_basic_string
(T0 const& t0, T1 const& t1, T2 const& t2) {
    return to_basic_string<Ch,Tr,Alloc> (t0,t1,t2,
    detail_string::noitem, 
    detail_string::noitem, 
    detail_string::noitem, 
    detail_string::noitem, 
    detail_string::noitem, 
    detail_string::noitem, 
    detail_string::noitem);
}

// 2 arguments
template <typename Ch, typename Tr, typename Alloc
, typename T0, typename T1
>
std::basic_string<Ch,Tr,Alloc> 
to_basic_string
(T0 const& t0, T1 const& t1) {
    return to_basic_string<Ch,Tr,Alloc> (t0,t1,
    detail_string::noitem, detail_string::noitem, detail_string::noitem, 
    detail_string::noitem, detail_string::noitem, detail_string::noitem, 
    detail_string::noitem, detail_string::noitem);
}


//
// to_basic_string_defaults
//

template <typename Ch
, typename T0, typename T1, typename T2, typename T3, typename T4, typename T5, typename T6, typename T7, typename T8, typename T9
>
std::basic_string<Ch, std::char_traits<Ch>, std::allocator<Ch> > 
to_basic_string_defaults
(T0 const& t0, T1 const& t1, T2 const& t2, T3 const& t3, T4 const& t4, T5 const& t5, T6 const& t6, T7 const& t7, T8 const& t8, T9 const& t9) {
    return to_basic_string<Ch, std::char_traits<Ch>, std::allocator<Ch> >
    (t0,t1,t2,t3,t4,t5,t6,t7,t8,t9);
}

// 9 arguments
template <typename Ch, typename T0, typename T1, typename T2, typename T3, typename T4, typename T5, typename T6, typename T7, typename T8>
std::basic_string<Ch, std::char_traits<Ch>, std::allocator<Ch> > 
to_basic_string_defaults
(T0 const& t0, T1 const& t1, T2 const& t2, T3 const& t3, T4 const& t4, T5 const& t5, T6 const& t6, T7 const& t7, T8 const& t8) {
    return to_basic_string<Ch, std::char_traits<Ch>, std::allocator<Ch> >
    (t0,t1,t2,t3,t4,t5,t6,t7,t8);
}

// 8 arguments
template <typename Ch, typename T0, typename T1, typename T2, typename T3, typename T4, typename T5, typename T6, typename T7>
std::basic_string<Ch, std::char_traits<Ch>, std::allocator<Ch> > 
to_basic_string_defaults
(T0 const& t0, T1 const& t1, T2 const& t2, T3 const& t3, T4 const& t4, T5 const& t5, T6 const& t6, T7 const& t7) {
    return to_basic_string<Ch, std::char_traits<Ch>, std::allocator<Ch> >
    (t0,t1,t2,t3,t4,t5,t6,t7);
}

// 7 arguments
template <typename Ch, typename T0, typename T1, typename T2, typename T3, typename T4, typename T5, typename T6>
std::basic_string<Ch, std::char_traits<Ch>, std::allocator<Ch> > 
to_basic_string_defaults
(T0 const& t0, T1 const& t1, T2 const& t2, T3 const& t3, T4 const& t4, T5 const& t5, T6 const& t6) {
    return to_basic_string<Ch, std::char_traits<Ch>, std::allocator<Ch> >
    (t0,t1,t2,t3,t4,t5,t6);
}

// 6 arguments
template <typename Ch, typename T0, typename T1, typename T2, typename T3, typename T4, typename T5>
std::basic_string<Ch, std::char_traits<Ch>, std::allocator<Ch> > 
to_basic_string_defaults
(T0 const& t0, T1 const& t1, T2 const& t2, T3 const& t3, T4 const& t4, T5 const& t5) {
    return to_basic_string<Ch, std::char_traits<Ch>, std::allocator<Ch> >
    (t0,t1,t2,t3,t4,t5);
}

// 5 arguments
template <typename Ch, typename T0, typename T1, typename T2, typename T3, typename T4>
std::basic_string<Ch, std::char_traits<Ch>, std::allocator<Ch> > 
to_basic_string_defaults
(T0 const& t0, T1 const& t1, T2 const& t2, T3 const& t3, T4 const& t4) {
    return to_basic_string<Ch, std::char_traits<Ch>, std::allocator<Ch> >
    (t0,t1,t2,t3,t4);
}

// 4 arguments
template <typename Ch, typename T0, typename T1, typename T2, typename T3>
std::basic_string<Ch, std::char_traits<Ch>, std::allocator<Ch> > 
to_basic_string_defaults
(T0 const& t0, T1 const& t1, T2 const& t2, T3 const& t3) {
    return to_basic_string<Ch, std::char_traits<Ch>, std::allocator<Ch> >
    (t0,t1,t2,t3);
}

// 3 arguments
template <typename Ch, typename T0, typename T1, typename T2>
std::basic_string<Ch, std::char_traits<Ch>, std::allocator<Ch> > 
to_basic_string_defaults
(T0 const& t0, T1 const& t1, T2 const& t2) {
    return to_basic_string<Ch, std::char_traits<Ch>, std::allocator<Ch> >
    (t0,t1,t2);
}

// 2 arguments
template <typename Ch, typename T0, typename T1>
std::basic_string<Ch, std::char_traits<Ch>, std::allocator<Ch> > 
to_basic_string_defaults
(T0 const& t0, T1 const& t1) {
    return to_basic_string<Ch, std::char_traits<Ch>, std::allocator<Ch> >
    (t0,t1);
}

//
// to_string
//


template <typename T0, typename T1, typename T2, typename T3, typename T4, typename T5, typename T6, typename T7, typename T8, typename T9
>
std::string to_string
(T0 const& t0, T1 const& t1, T2 const& t2, T3 const& t3, T4 const& t4, T5 const& t5, T6 const& t6, T7 const& t7, T8 const& t8, T9 const& t9) {
    return to_basic_string_defaults<char>(t0,t1,t2,t3,t4,t5,t6,t7,t8,t9);
}

// 9 arguments
template <typename T0, typename T1, typename T2, typename T3, typename T4, typename T5, typename T6, typename T7, typename T8
>
std::string  to_string
(T0 const& t0, T1 const& t1, T2 const& t2, T3 const& t3, T4 const& t4, T5 const& t5, T6 const& t6, T7 const& t7, T8 const& t8) {
    return to_basic_string_defaults<char>(t0,t1,t2,t3,t4,t5,t6,t7,t8);
}

// 8 arguments
template <typename T0, typename T1, typename T2, typename T3, typename T4, typename T5, typename T6, typename T7
>
std::string  to_string
(T0 const& t0, T1 const& t1, T2 const& t2, T3 const& t3, T4 const& t4, T5 const& t5, T6 const& t6, T7 const& t7) {
    return to_basic_string_defaults<char>(t0,t1,t2,t3,t4,t5,t6,t7);
}

// 7 arguments
template <typename T0, typename T1, typename T2, typename T3, typename T4, typename T5, typename T6
>
std::string  to_string
(T0 const& t0, T1 const& t1, T2 const& t2, T3 const& t3, T4 const& t4, T5 const& t5, T6 const& t6) {
    return to_basic_string_defaults<char>(t0,t1,t2,t3,t4,t5,t6);
}

// 6 arguments
template <typename T0, typename T1, typename T2, typename T3, typename T4, typename T5
>
std::string  to_string
(T0 const& t0, T1 const& t1, T2 const& t2, T3 const& t3, T4 const& t4, T5 const& t5) {
    return to_basic_string_defaults<char>(t0,t1,t2,t3,t4,t5);
}

// 5 arguments
template <typename T0, typename T1, typename T2, typename T3, typename T4>
std::string  to_string
(T0 const& t0, T1 const& t1, T2 const& t2, T3 const& t3, T4 const& t4) {
    return to_basic_string_defaults<char>(t0,t1,t2,t3,t4);
}

// 4 arguments
template <typename T0, typename T1, typename T2, typename T3>
std::string  to_string
(T0 const& t0, T1 const& t1, T2 const& t2, T3 const& t3) {
    return to_basic_string_defaults<char>(t0,t1,t2,t3);
}

// 3 arguments
template <typename T0, typename T1, typename T2>
std::string  to_string
(T0 const& t0, T1 const& t1, T2 const& t2) {
    return to_basic_string_defaults<char>(t0,t1,t2);
}

// 2 arguments
template <typename T0, typename T1>
std::string  to_string
(T0 const& t0, T1 const& t1) {
    return to_basic_string_defaults<char>(t0,t1);
}

} // string
}} // cxxomfort::impl

#endif


#endif
