#ifndef CXXOMFORT_IMPL_USING_cxxo_type_traits_HPP
#define CXXOMFORT_IMPL_USING_cxxo_type_traits_HPP

// this header lifts the type_traits in cxxomfort::traits to namespace std

#include <cxxomfort/base.hpp>
#include <cxxomfort/impl/07-type_traits.hpp>

#if defined(CXXOMFORT_USE_INTERNAL_TR1)

namespace std {
	// OpenWatcom already defines these
	#if (CXXOMFORT_COMPILER_ID==CXXO_COMPILERID_OW)
	#else
	using ::cxxomfort::traits::integral_constant;
	using ::cxxomfort::traits::false_type;
	using ::cxxomfort::traits::true_type;
	
	using ::cxxomfort::traits::is_same;

	using ::cxxomfort::traits::is_integral;
	using ::cxxomfort::traits::is_floating_point;
	using ::cxxomfort::traits::is_arithmetic;
	using ::cxxomfort::traits::is_void;
	using ::cxxomfort::traits::is_fundamental;
    
    using ::cxxomfort::traits::is_signed;
    using ::cxxomfort::traits::is_unsigned;

	using ::cxxomfort::traits::is_const;
	using ::cxxomfort::traits::is_volatile;
	using ::cxxomfort::traits::add_const;
	using ::cxxomfort::traits::add_volatile;
	using ::cxxomfort::traits::remove_const;
	using ::cxxomfort::traits::remove_volatile;
	using ::cxxomfort::traits::add_cv;
	using ::cxxomfort::traits::remove_cv;

	using ::cxxomfort::traits::is_pointer;
	using ::cxxomfort::traits::is_reference;
	using ::cxxomfort::traits::add_pointer;
	using ::cxxomfort::traits::add_reference;
	using ::cxxomfort::traits::remove_pointer;
	using ::cxxomfort::traits::remove_reference;

	#endif

	using ::cxxomfort::traits::is_array;
	using ::cxxomfort::traits::rank;
	using ::cxxomfort::traits::extent;
	using ::cxxomfort::traits::remove_extent;

	using ::cxxomfort::traits::is_function;
	using ::cxxomfort::traits::is_member_function_pointer;
	using ::cxxomfort::traits::is_member_object_pointer;

	#if (CXXO_COMPILER_SUPPORT_type_intrinsics)
	using ::cxxomfort::traits::is_enum;
	using ::cxxomfort::traits::is_union;
	using ::cxxomfort::traits::is_class;
	using ::cxxomfort::traits::is_pod;
	#endif

	// these function correctly only if there is support for compiler intrinsics
	// otherwise they deliver false negatives
	
	using ::cxxomfort::traits::is_scalar;
	using ::cxxomfort::traits::is_compound;

}

#endif // internal tr1

#endif
