#ifndef CXXOMFORT_UTIL_CSTRINGVIEW_HPP
#define CXXOMFORT_UTIL_CSTRINGVIEW_HPP
/**
 * @file
 * @brief Includes of <tt>cstring_view</tt> proposal implementation
 * @ingroup cxxomfort-utils
 * 
 * Implementation details:
 * 
 * * missing allocator support, raw strings only
 * 
 */

#define CXXOMFORT_IMPLEMENTS_p1402 1
#define CXXOMFORT_IMPLEMENTS_cstring_view CXXOMFORT_IMPLEMENTS_p1402

#include <cxxomfort/config.hpp>
#include "../impl/p1402-cstring_view.hpp"


namespace cxxomfort {
    using cxxomfort::impl::basic_cstring_view;
    using cxxomfort::impl::null_terminated_t;
    using cxxomfort::impl::null_terminated;
    using cxxomfort::impl::cstring_view;
    using cxxomfort::impl::wcstring_view;

    #if (CXXOMFORT_CXX_STD >= 2011)
    
namespace literals {

//! UDL for creating a @c cstring_view .
constexpr inline
cxxomfort::cstring_view operator"" _csv (char *const s, size_t l) noexcept { return cxxomfort::cstring_view(s,l); }

//! UDL for creating a @c wcstring_view .
constexpr inline
cxxomfort::wcstring_view operator"" _csv (wchar_t *const s, size_t l) noexcept { return cxxomfort::wcstring_view(s,l); }


}
    #endif
    
} // cxxomfort

#endif // file
