#ifndef CXXOMFORT_UTIL_TRAITS_TN_HPP
#define CXXOMFORT_UTIL_TRAITS_TN_HPP

#if (defined(CXXOMFORT_NOTICES) && CXXOMFORT_NOTICES>2)
    #pragma message CXXO_NOTICE("")
#endif

#include <type_traits>
#include "../impl/07-type_traits.hpp"
//
// Triviality traits from C++11
//

#if (CXXOMFORT_CXX_STD < 2011)
    #if (CXXOMFORT_CXX_EMULATION < 2011)
        #define CXXO_enable_is_trivially
    #elif (CXXO_COMPILER_SUPPORT_std_is_trivially==0)
        #define CXXO_enable_is_trivially
    #endif
#endif




//
// is_nothrow_...
//

#if (CXXOMFORT_CXX_STD < 2011) 
    #if (CXXO_COMPILER_SUPPORT_std_is_trivially==0)
        #define CXXO_enable_is_nothrow
    #endif
#endif

#if (defined(CXXO_enable_is_nothrow))
namespace std {
}
#undef CXXO_enable_is_nothrow
#endif // cxx11

// GCC 4.7 misses some nothrow traits despite announcing C++11 mode
#if (CXXO_COMPILERREQ(CXXO_COMPILERID_GCC , == 407) && CXXOMFORT_CXX_EMULATION==2011)
namespace std {
    template <typename T>
    struct is_nothrow_destructible
    : cxxomfort::traits::integral_constant<bool, __has_trivial_destructor(T)> {};
}
#endif

//
// is_default_constructible (for c++03)
// we approximate it by using the trivially and nothrow traits
//



#if (CXXO_COMPILERREQ(CXXO_COMPILERID_MSC,<1700))
namespace std {
    template <typename T>
    struct is_default_constructible
    : std::integral_constant<bool, is_trivially_default_constructible<T>::value || is_nothrow_default_constructible<T>::value>
    {};

} // std::
#endif





#endif // HEADER GUARD
